Index: issm/branches/trunk-jpl-damage/src/c/solutions/hydrology_core_step.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/hydrology_core_step.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/hydrology_core_step.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -13,9 +13,9 @@
 #include "../solvers/solvers.h"
 
-void hydrology_core_step(FemModel* femmodel,int step, double time){
+void hydrology_core_step(FemModel* femmodel,int step, IssmDouble time){
 	
 	bool modify_loads=true;
 
-	_printf_(VerboseSolution(),"   computing water column\n");
+	if(VerboseSolution()) _pprintLine_("   computing water column");
 	femmodel->SetCurrentConfiguration(HydrologyAnalysisEnum);
 	solver_nonlinear(femmodel,modify_loads);
Index: issm/branches/trunk-jpl-damage/src/c/solutions/issm.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/issm.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/issm.cpp	(revision 12878)
@@ -30,8 +30,13 @@
 
 	/*time*/
-	double   start, finish;
-	double   start_core, finish_core;
-	double   start_init, finish_init;
+	IssmPDouble   start, finish;
+	IssmPDouble   start_core, finish_core;
+	IssmPDouble   start_init, finish_init;
 	int      ierr;
+
+	/*profiling*/   
+	bool profiling = false;
+	IssmPDouble Time_start, Flops_start;
+	IssmPDouble Solution_time, Memory_use, Current_flops;
 
 	ISSMBOOT();
@@ -40,5 +45,5 @@
 	#ifdef _HAVE_PETSC_
 	ierr=PetscInitialize(&argc,&argv,(char*)0,"");  
-	if(ierr) _error_("Could not initialize Petsc");
+	if(ierr) _error2_("Could not initialize Petsc");
 	#else
 	#ifdef _HAVE_MPI_
@@ -50,5 +55,5 @@
 	MPI_Barrier(MPI_COMM_WORLD); start=MPI_Wtime();
 	#else
-	start=(double)clock();
+	start=(IssmPDouble)clock();
 	#endif
 
@@ -60,8 +65,8 @@
 
 	/*First process inputs*/
-	_printf_(true,"\n");
-	_printf_(true,"Ice Sheet System Model (%s) version %s\n",PACKAGE_NAME,PACKAGE_VERSION);
-	_printf_(true,"(website: %s contact: %s)\n",PACKAGE_URL,PACKAGE_BUGREPORT);
-	_printf_(true,"\n");
+	_pprintLine_("");
+	_pprintLine_("Ice Sheet System Model (" << PACKAGE_NAME << ") version " << PACKAGE_VERSION);
+	_pprintLine_("(website: " << PACKAGE_URL << " contact: " << PACKAGE_BUGREPORT << ")");
+	_pprintLine_("");
 	ProcessArguments(&solution_type,&binfilename,&outbinfilename,&petscfilename,&lockfilename,argc,argv);
 
@@ -73,5 +78,5 @@
 	MPI_Barrier(MPI_COMM_WORLD); start_init=MPI_Wtime();
 	#else
-	start_init=(double)clock();
+	start_init=(IssmPDouble)clock();
 	#endif
 	femmodel=new FemModel(binfilename,outbinfilename,solution_type,analyses,numanalyses);
@@ -94,22 +99,26 @@
 	femmodel->parameters->FindParam(&control_analysis,InversionIscontrolEnum);
 	femmodel->parameters->FindParam(&tao_analysis,InversionTaoEnum);
+	femmodel->parameters->FindParam(&profiling,DebugProfilingEnum); 
+
 	#ifdef _HAVE_MPI_
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
 	#else
-	finish_init=(double)clock();
-	#endif
-
-	_printf_(true,"call computational core:\n");
+	finish_init=(IssmPDouble)clock();
+	#endif
+
+	_pprintLine_("call computational core:");
 	#ifdef _HAVE_MPI_
 	MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
 	#else
-	start_core=(double)clock();
-	#endif
-	
+	start_core=(IssmPDouble)clock();
+	#endif
+	
+	if(profiling)ProfilingStart(&Time_start,&Flops_start);
+
 	if(dakota_analysis){
 		#ifdef _HAVE_DAKOTA_
 		Dakotax(femmodel);
 		#else
-		_error_("ISSM was not compiled with dakota support, cannot carry out dakota analysis!");
+		_error2_("ISSM was not compiled with dakota support, cannot carry out dakota analysis!");
 		#endif
 	}
@@ -121,5 +130,5 @@
 		 control_core(femmodel);
 		#else
-		_error_("ISSM was not compiled with control support, cannot carry out dakota analysis!");
+		_error2_("ISSM was not compiled with control support, cannot carry out dakota analysis!");
 		#endif
 	}
@@ -127,11 +136,20 @@
 		solutioncore(femmodel);
 	}
+
+	if(profiling){
+		ProfilingEnd(&Solution_time,&Memory_use,&Current_flops,Time_start,Flops_start);
+		femmodel->results->AddObject(new DoubleExternalResult(femmodel->results->Size()+1, ProfilingSolutionTimeEnum, Solution_time, 1, 0));
+		femmodel->results->AddObject(new DoubleExternalResult(femmodel->results->Size()+1, ProfilingCurrentMemEnum, Memory_use, 1, 0));
+		femmodel->results->AddObject(new DoubleExternalResult(femmodel->results->Size()+1, ProfilingCurrentFlopsEnum, Current_flops, 1, 0));
+	}
+
+
 	#ifdef _HAVE_MPI_
 	MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	#else
-	finish_core=(double)clock();
-	#endif
-	
-	_printf_(true,"write results to disk:\n");
+	finish_core=(IssmPDouble)clock();
+	#endif
+
+	_pprintLine_("write results to disk:");
 	OutputResultsx(femmodel->elements, femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,femmodel->results);
 
@@ -139,14 +157,14 @@
 	pfclose(output_fid,lockfilename);
 	if (waitonlock>0){
-		_printf_(true,"write lock file:\n");
+		_pprintLine_("write lock file:");
 		WriteLockFile(lockfilename);
 	}
 
-	/*Free ressources */
-	xfree((void**)&analyses);
-	xfree((void**)&lockfilename);
-	xfree((void**)&binfilename);
-	xfree((void**)&outbinfilename);
-	xfree((void**)&petscfilename);
+	/*Free resources */
+	xDelete<int>(analyses);
+	xDelete<char>(lockfilename);
+	xDelete<char>(binfilename);
+	xDelete<char>(outbinfilename);
+	xDelete<char>(petscfilename);
 	delete femmodel;
 
@@ -154,22 +172,29 @@
 	#ifdef _HAVE_MPI_
 	MPI_Barrier(MPI_COMM_WORLD); finish = MPI_Wtime( );
-	_printf_(true,"\n   %-34s %f seconds  \n","FemModel initialization elapsed time:",finish_init-start_init);
-	_printf_(true,"   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_(true,"\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
-	#else
-	finish=(double)clock();
-	_printf_(true,"\n   %-34s %f seconds  \n","FemModel initialization elapsed time:",(finish_init-start_init)/CLOCKS_PER_SEC);
-	_printf_(true,"   %-34s %f seconds  \n","Core solution elapsed time:",(finish_core-start_core)/CLOCKS_PER_SEC);
-	_printf_(true,"\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600/CLOCKS_PER_SEC),int(int((finish-start)/CLOCKS_PER_SEC)%3600/60),(int(finish-start)/CLOCKS_PER_SEC)%60);
-	#endif
-	
-		
+	_pprintLine_("");
+	_pprintLine_("   "<<setw(40)<<left<<"FemModel initialization elapsed time:"<<finish_init-start_init);
+	_pprintLine_("   "<<setw(40)<<left<<"Core solution elapsed time:"<<finish_core-start_core);
+	_pprintLine_("");
+	_pprintLine_("   Total elapsed time:"<<int((finish-start)/3600)<<" hrs "<<int(int(finish-start)%3600/60)<<" min "<<int(finish-start)%60<<" sec");
+	_pprintLine_("");
+	#else
+	finish=(IssmPDouble)clock();
+	_pprintLine_("");
+	_pprintLine_("   "<<setw(40)<<left<<"FemModel initialization elapsed time:"<<(finish_init-start_init)/CLOCKS_PER_SEC);
+	_pprintLine_("   "<<setw(40)<<left<<"Core solution elapsed time:"<<(finish_core-start_core)/CLOCKS_PER_SEC);
+	_pprintLine_("");
+	_pprintLine_("   Total elapsed time:"
+				<<int((finish-start)/CLOCKS_PER_SEC/3600)<<" hrs "
+				<<int(int(finish-start)/CLOCKS_PER_SEC%3600/60)<<" min "
+				<<int(finish-start)/CLOCKS_PER_SEC%60<<" sec");
+	_pprintLine_("");
+	#endif
 	
 	#ifdef _HAVE_PETSC_
-	_printf_(true,"closing MPI and Petsc\n");
+	_pprintLine_("closing MPI and Petsc");
 	PetscFinalize(); 
 	#else
 	#ifdef _HAVE_MPI_
-	_printf_(true,"closing MPI and Petsc\n");
+	_pprintLine_("closing MPI and Petsc");
 	MPI_Finalize();
 	#endif
Index: issm/branches/trunk-jpl-damage/src/c/solutions/kriging.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/kriging.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/kriging.cpp	(revision 12878)
@@ -0,0 +1,177 @@
+/*!\file:  kriging.cpp
+ * \brief: kriging main parallel program
+ */ 
+
+#include "../issm.h"
+#include "../include/globals.h"
+
+/*Local prototypes*/
+void ProcessArguments2(char** pbinfilename,char** poutbinfilename,char** plockfilename,int argc,char **argv);
+void ProcessInputfile(IssmDouble **px,IssmDouble **py,IssmDouble **pdata,int *pnobs,IssmDouble **px_interp,IssmDouble **py_interp,int *pninterp,Options **poptions,FILE* fid);
+
+int main(int argc,char **argv){
+
+	/*I/O: */
+	FILE *output_fid = NULL;
+	FILE *input_fid  = NULL;
+	bool  waitonlock = false;
+
+	/*File names*/
+	char *lockfilename   = NULL;
+	char *binfilename    = NULL;
+	char *outbinfilename = NULL;
+
+	/*Input*/
+	int      ninterp,nobs;
+	IssmDouble  *x        = NULL;
+	IssmDouble  *y        = NULL;
+	IssmDouble  *data     = NULL;
+	IssmDouble  *x_interp = NULL;
+	IssmDouble  *y_interp = NULL;
+	Options *options  = NULL;
+
+	/*Output*/
+	IssmDouble *predictions = NULL;
+	IssmDouble *error       = NULL;
+
+	ISSMBOOT();
+
+	/*Initialize environments: Petsc, MPI, etc...: */
+#ifdef _HAVE_PETSC_
+	int ierr=PetscInitialize(&argc,&argv,(char*)0,"");  
+	if(ierr) _error2_("Could not initialize Petsc");
+#else
+#ifdef _HAVE_MPI_
+	MPI_Init(&argc,&argv);
+#endif
+#endif
+
+	/*Size and rank: */
+#ifdef _HAVE_MPI_
+	MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);  
+	MPI_Comm_size(MPI_COMM_WORLD,&num_procs); 
+#endif
+
+	/*First process inputs*/
+	_pprintLine_("");
+	_pprintLine_("Ice Sheet System Model (" << PACKAGE_NAME << ") version " << PACKAGE_VERSION);
+	_pprintLine_("(website: " << PACKAGE_URL << " contact: " << PACKAGE_BUGREPORT << ")");
+	_pprintLine_("");
+	ProcessArguments2(&binfilename,&outbinfilename,&lockfilename,argc,argv);
+
+	/*Process input files*/
+	input_fid=pfopen(binfilename,"rb");
+	ProcessInputfile(&x,&y,&data,&nobs,&x_interp,&y_interp,&ninterp,&options,input_fid);
+	pfclose(input_fid,binfilename);
+
+	_pprintLine_("call computational core:");
+	pKrigingx(&predictions,&error,x,y,data,nobs,x_interp,y_interp,ninterp,options);
+
+	_pprintLine_("write results to disk:");
+	Results *results = new Results();
+	if(my_rank==0){
+		output_fid=pfopen(outbinfilename,"wb");
+		results->AddObject(new DoubleVecExternalResult(results->Size()+1,0,predictions,ninterp,1,0));
+		results->AddObject(new DoubleVecExternalResult(results->Size()+1,1,error,ninterp,1,0));
+		for(int i=0;i<results->Size();i++){
+			ExternalResult* result=(ExternalResult*)results->GetObjectByOffset(i);
+			result->WriteData(output_fid,1);
+		}
+		pfclose(output_fid,outbinfilename);
+	}
+
+	/*Close output and petsc options file and write lock file if requested*/
+	_pprintLine_("write lock file:");
+	WriteLockFile(lockfilename);
+
+	/*Free ressources */
+	xDelete<char>(lockfilename);
+	xDelete<char>(binfilename);
+	xDelete<char>(outbinfilename);
+	xDelete<IssmDouble>(x);
+	xDelete<IssmDouble>(y);
+	xDelete<IssmDouble>(data);
+	xDelete<IssmDouble>(x_interp);
+	xDelete<IssmDouble>(y_interp);
+	xDelete<IssmDouble>(predictions);
+	xDelete<IssmDouble>(error);
+	delete options;
+	delete results;
+
+#ifdef _HAVE_PETSC_
+	_pprintLine_("closing MPI and Petsc");
+	PetscFinalize(); 
+#else
+#ifdef _HAVE_MPI_
+	_pprintLine_("closing MPI and Petsc");
+	MPI_Finalize();
+#endif
+#endif
+
+	/*end module: */
+	ISSMEND();
+
+	return 0; //unix success return;
+}
+
+void ProcessArguments2(char** pbinfilename,char** poutbinfilename,char** plockfilename,int argc,char **argv){
+
+	char *modelname      = NULL;
+	char *binfilename    = NULL;
+	char *outbinfilename = NULL;
+	char *lockfilename   = NULL;
+
+	if(argc<2)_error2_("Usage error: missing model name");
+	modelname=argv[2];
+	binfilename    = xNew<char>((strlen(modelname)+strlen(".bin")   +1)); sprintf(binfilename,   "%s%s",modelname,".bin");
+	outbinfilename = xNew<char>((strlen(modelname)+strlen(".outbin")+1)); sprintf(outbinfilename,"%s%s",modelname,".outbin");
+	lockfilename   = xNew<char>((strlen(modelname)+strlen(".lock")  +1)); sprintf(lockfilename,  "%s%s",modelname,".lock");
+
+	/*Clean up and assign output pointer*/
+	*pbinfilename=binfilename;
+	*poutbinfilename=outbinfilename;
+	*plockfilename=lockfilename;
+}
+
+void ProcessInputfile(IssmDouble **px,IssmDouble **py,IssmDouble **pdata,int *pnobs,IssmDouble **px_interp,IssmDouble **py_interp,int *pninterp,Options **poptions,FILE* fid){
+
+	int      ninterp,nobs,numoptions;
+	IssmDouble  *x        = NULL;
+	IssmDouble  *y        = NULL;
+	IssmDouble  *data     = NULL;
+	IssmDouble  *x_interp = NULL;
+	IssmDouble  *y_interp = NULL;
+	Options *options  = NULL;
+	Option  *option   = NULL;
+
+	int dummy,M,N;
+	IoModel* iomodel = new IoModel();
+	iomodel->fid=fid;
+	iomodel->CheckEnumSync();
+	iomodel->FetchData(&x,&M,&N,0);        nobs=M*N;
+	iomodel->FetchData(&y,&M,&N,1);        _assert_(M*N==nobs);
+	iomodel->FetchData(&data,&M,&N,2);     _assert_(M*N==nobs);
+	iomodel->FetchData(&x_interp,&M,&N,3); ninterp=M*N;
+	iomodel->FetchData(&y_interp,&M,&N,4); _assert_(M*N==ninterp);
+
+	/*Read options*/
+	options = new Options();
+	iomodel->LastIndex(&N);
+	numoptions=(int)((N-4)/2);
+	for(int i=0;i<numoptions;i++){
+		iomodel->FetchData(&option,5+2*i);
+		options->AddOption(option);
+		option=NULL;
+	}
+
+	/*Assign output pointer*/
+	*px        = x;
+	*py        = y;
+	*pdata     = data;
+	*pnobs     = nobs;
+	*px_interp = x_interp;
+	*py_interp = y_interp;
+	*pninterp  = ninterp;
+	*poptions  = options;
+	delete iomodel;
+}
Index: issm/branches/trunk-jpl-damage/src/c/solutions/objectivefunction.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/objectivefunction.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/objectivefunction.cpp	(revision 12878)
@@ -3,5 +3,5 @@
  */ 
 
-/*include files: {{{1*/
+/*include files: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -11,5 +11,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -20,10 +20,10 @@
 /*}}}*/
 
-double objectivefunction(double search_scalar,OptArgs* optargs){
+IssmDouble objectivefunction(IssmDouble search_scalar,OptArgs* optargs){
 
 	int i;  
 	
 	/*output: */
-	double J;
+	IssmDouble J;
 	
 	/*parameters: */
@@ -49,5 +49,5 @@
 	}
 	else{
-		_error_("Solution %s not implemented yet",EnumToStringx(solution_type));
+		_error2_("Solution " << EnumToStringx(solution_type) << " not implemented yet");
 	}
 
@@ -66,5 +66,5 @@
 	}
 	else{
-		_error_("Solution %s not implemented yet",EnumToStringx(solution_type));
+		_error2_("Solution " << EnumToStringx(solution_type) << " not implemented yet");
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/solutions/prognostic_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/prognostic_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/prognostic_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -16,4 +16,5 @@
 	/*parameters: */
 	bool save_results;
+	bool issmbgradients,ispdd,isdelta18o;
 
 	/*activate formulation: */
@@ -22,10 +23,25 @@
 	/*recover parameters: */
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
+	femmodel->parameters->FindParam(&issmbgradients,SurfaceforcingsIssmbgradientsEnum);
+	femmodel->parameters->FindParam(&ispdd,SurfaceforcingsIspddEnum);
+	femmodel->parameters->FindParam(&isdelta18o,SurfaceforcingsIsdelta18oEnum);
 
-	_printf_(VerboseSolution(),"   call computational core\n");
+	if(issmbgradients){
+	  _printf_(VerboseSolution(),"	call smb gradients module\n");
+	  SmbGradientsx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+	}
+	if(ispdd){
+		if(isdelta18o){
+			if(VerboseSolution()) _pprintLine_("   call Delta18oParametrization module");
+			Delta18oParameterizationx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+		} 
+		if(VerboseSolution()) _pprintLine_("   call positive degree day module");
+		PositiveDegreeDayx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+	}
+	if(VerboseSolution()) _pprintLine_("   call computational core");
 	solver_linear(femmodel);
-		
+	
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,ThicknessEnum);
 	}
Index: issm/branches/trunk-jpl-damage/src/c/solutions/solutions.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/solutions.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/solutions.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define SOLUTIONS_H_
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 
@@ -18,5 +18,5 @@
 void diagnostic_core(FemModel* femmodel);
 void hydrology_core(FemModel* femmodel);
-void hydrology_core_step(FemModel* femmodel,int step, double time);
+void hydrology_core_step(FemModel* femmodel,int step, IssmDouble time);
 void thermal_core(FemModel* femmodel);
 void enthalpy_core(FemModel* femmodel);
@@ -30,18 +30,18 @@
 void steadystate_core(FemModel* femmodel);
 void transient_core(FemModel* femmodel);
-double objectivefunction(double search_scalar,OptArgs* optargs);
+IssmDouble objectivefunction(IssmDouble search_scalar,OptArgs* optargs);
 
 //convergence:
 void convergence(bool* pconverged, Matrix* K_ff,Vector* p_f,Vector* u_f,Vector* u_f_old,Parameters* parameters);
-bool controlconvergence(double J,double tol_cm);
+bool controlconvergence(IssmDouble J,IssmDouble tol_cm);
 bool steadystateconvergence(FemModel* femmodel);
 
 //optimization
-int GradJSearch(double* search_vector,FemModel* femmodel,int step);
+int GradJSearch(IssmDouble* search_vector,FemModel* femmodel,int step);
 
 //diverse
 void ProcessArguments(int* solution,char** pbinname,char** poutbinname,char** ppetscname,char** plockname,int argc,char **argv);
 void WriteLockFile(char* filename);
-void controlrestart(FemModel* femmodel,double* J);
+void controlrestart(FemModel* femmodel,IssmDouble* J);
 void ResetBoundaryConditions(FemModel* femmodel, int analysis_type);
 
Index: issm/branches/trunk-jpl-damage/src/c/solutions/steadystate_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/steadystate_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/steadystate_core.cpp	(revision 12878)
@@ -9,6 +9,7 @@
 #endif
 
+#include "../include/include.h"
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -16,5 +17,4 @@
 #include "./solutions.h"
 #include "../modules/modules.h"
-#include "../include/include.h"
 #include "../solvers/solvers.h"
 
@@ -43,5 +43,5 @@
 	for(;;){
 	
-		_printf_(VerboseSolution(),"%s%i\n","   computing temperature and velocity for step: ",step);
+		if(VerboseSolution()) _pprintLine_("   computing temperature and velocity for step: " << step);
 		#ifdef _HAVE_THERMAL_
 		if(isenthalpy==0){
@@ -52,20 +52,20 @@
 		}
 		#else
-		_error_("ISSM was not compiled with thermal capabilities. Exiting");
+		_error2_("ISSM was not compiled with thermal capabilities. Exiting");
 		#endif
 
-		_printf_(VerboseSolution(),"%s\n","   computing new velocity");
+		if(VerboseSolution()) _pprintLine_("   computing new velocity");
 		diagnostic_core(femmodel);
 
 		if (step>1){
-			_printf_(VerboseSolution(),"%s\n","   checking velocity, temperature and pressure convergence");
+			if(VerboseSolution()) _pprintLine_("   checking velocity, temperature and pressure convergence");
 			if(steadystateconvergence(femmodel)) break;
 		}
 		if(step>maxiter){
-			_printf_(VerboseSolution(),"%s%i%s\n","   maximum number steadystate iterations ",maxiter," reached");
+			if(VerboseSolution()) _pprintLine_("   maximum number steadystate iterations " << maxiter << " reached");
 			break;
 		}
 		
-		_printf_(VerboseSolution(),"%s\n","   saving velocity, temperature and pressure to check for convergence at next step");
+		if(VerboseSolution()) _pprintLine_("   saving velocity, temperature and pressure to check for convergence at next step");
 		InputDuplicatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum,VxPicardEnum);
 		InputDuplicatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VyEnum,VyPicardEnum);
@@ -79,5 +79,5 @@
 	
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum);
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VyEnum);
@@ -93,4 +93,4 @@
 
 	/*Free ressources:*/
-	xfree((void**)&requested_outputs);
+	xDelete<int>(requested_outputs);
 }
Index: issm/branches/trunk-jpl-damage/src/c/solutions/steadystateconvergence.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/steadystateconvergence.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/steadystateconvergence.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 #endif
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../Container/Container.h"
@@ -28,5 +28,5 @@
 	int temperatureenums[2]={TemperatureEnum,TemperatureOldEnum};
 	int convergencecriterion[1]={RelativeEnum}; //criterions for convergence, RelativeEnum or AbsoluteEnum 
-	double convergencecriterionvalue[1]; //value of criterion to be respected
+	IssmDouble convergencecriterionvalue[1]; //value of criterion to be respected
 
 	/*retrieve parameters: */
Index: issm/branches/trunk-jpl-damage/src/c/solutions/surfaceslope_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/surfaceslope_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/surfaceslope_core.cpp	(revision 12878)
@@ -5,5 +5,5 @@
 #include "./solutions.h"
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -19,5 +19,5 @@
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
 
-	_printf_(VerboseSolution(),"%s\n","computing slope...");
+	if(VerboseSolution()) _pprintLine_("computing slope...");
 
 	/*Call on core computations: */
@@ -28,5 +28,5 @@
 	
 	if(save_results){
-		_printf_(VerboseSolution(),"saving results:\n");
+		if(VerboseSolution()) _pprintLine_("saving results:");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceSlopeXEnum);
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceSlopeYEnum);
Index: issm/branches/trunk-jpl-damage/src/c/solutions/thermal_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/thermal_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/thermal_core.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -16,5 +16,5 @@
 
 	/*intermediary*/
-	double melting_offset;
+	IssmDouble melting_offset;
 	bool   save_results;
 	bool   dakota_analysis  = false;
@@ -29,14 +29,14 @@
 	}
 
-	_printf_(VerboseSolution(),"   computing temperatures\n");
+	if(VerboseSolution()) _pprintLine_("   computing temperatures");
 	femmodel->SetCurrentConfiguration(ThermalAnalysisEnum);
 	solver_thermal_nonlinear(femmodel);
 
-	_printf_(VerboseSolution(),"   computing melting\n");
+	if(VerboseSolution()) _pprintLine_("   computing melting");
 	femmodel->SetCurrentConfiguration(MeltingAnalysisEnum);
 	solver_linear(femmodel);
 
 	if(save_results){
-		_printf_(VerboseSolution(),"   saving results\n");
+		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,TemperatureEnum);
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BasalforcingsMeltingRateEnum);
Index: issm/branches/trunk-jpl-damage/src/c/solutions/transient_core.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/transient_core.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/transient_core.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -23,5 +23,5 @@
 
 	/*parameters: */
-	double starttime,finaltime,dt,yts;
+	IssmDouble starttime,finaltime,dt,yts;
 	bool   isdiagnostic,isprognostic,isthermal,isgroundingline,isenthalpy;
 	bool   save_results,dakota_analysis;
@@ -34,5 +34,5 @@
 	/*intermediary: */
 	int    step;
-	double time;
+	IssmDouble time;
 
 	//first recover parameters common to all solutions
@@ -86,5 +86,5 @@
 		femmodel->parameters->SetParam(step,StepEnum);
 
-		_printf_(VerboseSolution(),"iteration %i/%g  time [yr]: %-7.3g (time step: %.2g)\n",step,floor((finaltime-time)/dt)+step,time/yts,dt/yts);
+		if(VerboseSolution()) _pprintLine_("iteration " << step << "/" << floor((finaltime-time)/dt)+step << "  time [yr]: " << time/yts << " (time step: " << dt/yts << ")");
 		if(step%output_frequency==0 || time==finaltime)
 		 save_results=true;
@@ -94,5 +94,5 @@
 
 		if(isthermal && dim==3){
-			_printf_(VerboseSolution(),"   computing temperatures\n");
+			if(VerboseSolution()) _pprintLine_("   computing temperatures");
 			#ifdef _HAVE_THERMAL_
 			if(isenthalpy==0){
@@ -103,30 +103,30 @@
 			}
 			#else
-			_error_("ISSM was not compiled with thermal capabilities. Exiting");
+			_error2_("ISSM was not compiled with thermal capabilities. Exiting");
 			#endif
 		}
-
+		
 		if(isdiagnostic){
-			_printf_(VerboseSolution(),"   computing new velocity\n");
+			if(VerboseSolution()) _pprintLine_("   computing new velocity");
 			#ifdef _HAVE_DIAGNOSTIC_
 			diagnostic_core(femmodel);
 			#else
-			_error_("ISSM was not compiled with diagnostic capabilities. Exiting");
+			_error2_("ISSM was not compiled with diagnostic capabilities. Exiting");
 			#endif
 		}
 
 		if(isprognostic){
-			_printf_(VerboseSolution(),"   computing new thickness\n");
+			if(VerboseSolution()) _pprintLine_("   computing new thickness");
 			prognostic_core(femmodel);
-			_printf_(VerboseSolution(),"   updating vertices positions\n");
+			if(VerboseSolution()) _pprintLine_("   updating vertices positions");
 			UpdateVertexPositionsx(femmodel->elements, femmodel->nodes,femmodel->vertices,femmodel->loads, femmodel->materials, femmodel->parameters); 
 		}
 
 		if(isgroundingline){
-			_printf_(VerboseSolution(),"   computing new grounding line position\n");
+			if(VerboseSolution()) _pprintLine_("   computing new grounding line position");
 			#ifdef _HAVE_GROUNDINGLINE_
 			GroundinglineMigrationx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
 			#else
-			_error_("ISSM was not compiled with grounding line migration capabilities. Exiting");
+			_error2_("ISSM was not compiled with grounding line migration capabilities. Exiting");
 			#endif
 		}
@@ -134,5 +134,5 @@
 		/*unload results*/
 		if(save_results){
-			_printf_(VerboseSolution(),"   saving transient results\n");
+			if(VerboseSolution()) _pprintLine_("   saving transient results");
 			InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceEnum);
 			InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BedEnum);
@@ -141,5 +141,5 @@
 			RequestedOutputsx(femmodel->results,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,requested_outputs,numoutputs);
 
-			_printf_(VerboseSolution(),"   saving temporary results\n");
+			if(VerboseSolution()) _pprintLine_("   saving temporary results");
 			OutputResultsx(femmodel->elements, femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,femmodel->results);
 		}
@@ -147,4 +147,4 @@
 
 	/*Free ressources:*/
-	xfree((void**)&requested_outputs);
+	xDelete<int>(requested_outputs);
 }
Index: issm/branches/trunk-jpl-damage/src/c/solvers/solver_adjoint_linear.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solvers/solver_adjoint_linear.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solvers/solver_adjoint_linear.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../modules/modules.h"
Index: issm/branches/trunk-jpl-damage/src/c/solvers/solver_linear.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solvers/solver_linear.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solvers/solver_linear.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../modules/modules.h"
